leetcode【213】【tag DP】House Robber II【c++版本,时间O(n),空间O(1)】

问题描述:

You are a professional robber planning to rob houses along a street. Each house has a certain amount of money stashed. All houses at this place are arranged in a circle. That means the first house is the neighbor of the last one. Meanwhile, adjacent houses have security system connected and it will automatically contact the police if two adjacent houses were broken into on the same night.

Given a list of non-negative integers representing the amount of money of each house, determine the maximum amount of money you can rob tonight without alerting the police.

Example 1:

Input: [2,3,2]
Output: 3
Explanation: You cannot rob house 1 (money = 2) and then rob house 3 (money = 2),
             because they are adjacent houses.

Example 2:

Input: [1,2,3,1]
Output: 4
Explanation: Rob house 1 (money = 1) and then rob house 3 (money = 3).
             Total amount you can rob = 1 + 3 = 4.

源码:

自己高腾了半天,没搞出来,最后还是翻了一下人家的博客。

对上一题不了解的同学可以先看一下这个leetcode【198】【tag DP】House Robber【c++版本,动态规划,时间空间O(n)均100%】。这题加了一个限制条件就是头尾属于邻居。

这时候选0就不能选n-1,相当于啊求[0,n-2]之间的最大值。选n-1就不能选0,相当于求[1,n-1]之间的最大值。

有个小技巧,对动态规划降维,因为动态规划只用到了前两个状态,所以只需要一个a和一个b来存储前两个状态即可。

class Solution {
public:
    int help(vector<int>& nums, int left, int right){
        int a=nums[left], b=max(nums[left], nums[left+1]);
        for (int i=left+2; i<=right; i++){
            int tmp = max(a+nums[i], b);
            a = b;
            b = tmp;
        }
        return b;
    }
    
    int rob(vector<int>& nums) {
        int n = nums.size();
        if (n==0)   return 0;
        if (n==1)   return nums[0];
        if (n==2)   return max(nums[0], nums[1]);
        return max(help(nums, 0, n-2), help(nums, 1, n-1));
    }
};

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值